﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.RadControlSpy;

namespace _557359
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            radScheduler1.CellFormatting += new EventHandler<SchedulerCellEventArgs>(radScheduler1_CellFormatting);
        }

        void radScheduler1_CellFormatting(object sender, SchedulerCellEventArgs e)
        {
            if (e.CellElement.Class == "SchedulerCellElement" && e.CellElement.View.GetResources() != null)
            {
                string name = e.CellElement.View.GetResources()[0].Name;
                DayOfWeek day = e.CellElement.Date.DayOfWeek;
                int hour = e.CellElement.Date.Hour;
                if (name == "Dr Alan Smith")
                {
                    if (day == DayOfWeek.Monday && (hour < 9 || (hour > 12 && hour < 16) || hour > 18))
                    {
                        e.CellElement.Enabled = false;
                    }

                    if (day == DayOfWeek.Tuesday || day == DayOfWeek.Wednesday || day == DayOfWeek.Thursday)
                    {
                        e.CellElement.Enabled = false;
                    }

                    if (day == DayOfWeek.Friday && (hour < 12 || (hour > 14 && hour < 18) || hour > 20))
                    {
                        e.CellElement.Enabled = false;
                    }
                }
                else if (name == "Dr Anne Dodsworth")
                {
                    if (day == DayOfWeek.Tuesday || day == DayOfWeek.Wednesday || day == DayOfWeek.Thursday || (hour < 12 || hour > 18))
                    {
                        e.CellElement.Enabled = false;
                    }
                }
                else if (name == "Dr Boyan Mastoni")
                {
                    if (day == DayOfWeek.Monday || day == DayOfWeek.Friday || (hour < 8 || (hour > 12 && hour < 12) || hour > 18))
                    {
                        e.CellElement.Enabled = false;
                    }
                }
                else
                {
                    e.CellElement.ResetValue(LightVisualElement.EnabledProperty, Telerik.WinControls.ValueResetFlags.Local);
                }
            }
            else
            {
                e.CellElement.ResetValue(LightVisualElement.EnabledProperty, Telerik.WinControls.ValueResetFlags.Local);
            }
        }

        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);

            radScheduler1.ActiveViewType = SchedulerViewType.WorkWeek;
            SchedulerDayViewGroupedByResourceElement headerElement = this.radScheduler1.SchedulerElement.ViewElement as SchedulerDayViewGroupedByResourceElement;
            headerElement.ResourceHeaderHeight = 135;
            radScheduler1.GetWeekView().WorkTime.Start = new TimeSpan(07, 00, 00);
            radScheduler1.GetWeekView().WorkTime.End = new TimeSpan(20, 00, 00);

            SchedulerWeekView weekView = this.radScheduler1.GetWeekView();
            weekView.RulerStartScale = weekView.WorkTime.Start.Hours;
            weekView.RulerEndScale = weekView.WorkTime.End.Hours;
        }
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            Color[] colors = new Color[] { Color.LightBlue, Color.LightGreen, Color.LightYellow, Color.Red, Color.Orange, Color.Pink, Color.Purple, Color.Peru, Color.PowderBlue };
            string[] names = new string[] { "Dr Alan Smith", "Dr Anne Dodsworth", "Dr Boyan Mastoni" };
            for (int i = 0; i < names.Length; i++)
            {
                Resource resource = new Resource();
                resource.Id = new EventId(i);
                resource.Name = names[i];
                resource.Color = colors[i];
                resource.Image = this.imageList1.Images[i];
                this.radScheduler1.Resources.Add(resource);
            }
            this.radScheduler1.GetDayView().ResourcesPerView = 3;
            this.radScheduler1.GroupType = GroupType.Resource;


            DateTime baseDate = DateTime.Today;
            DateTime[] start = new DateTime[] { baseDate.AddHours(14.0), baseDate.AddDays(1.0).AddHours(9.0), baseDate.AddDays(2.0).AddHours(13.0) };
            DateTime[] end = new DateTime[] { baseDate.AddHours(16.0), baseDate.AddDays(1.0).AddHours(15.0), baseDate.AddDays(2.0).AddHours(17.0) };

            string[] summaries = new string[] { "Mr. Brown", "Mr. White", "Mrs. Green", "Mrs Hilda", "Mr Peterson" };
            AppointmentBackground[] backgrounds = new AppointmentBackground[] { AppointmentBackground.Business, AppointmentBackground.MustAttend, AppointmentBackground.Personal };

            for (int i = 0; i < summaries.Length; i++)
            {
                Appointment appointment = new Appointment(start[i], end[i], summaries[i]);
                appointment.ResourceId = this.radScheduler1.Resources[0].Id;
                appointment.BackgroundId = (int)backgrounds[i];
                this.radScheduler1.Appointments.Add(appointment);
            }

        }

    }
}
